module Data.Aeson.DeriveUtils
where

import Data.Aeson.TH
import Data.Char
import Language.Haskell.TH.Syntax

deriveLensJSON :: Name -> Q [Dec]
deriveLensJSON = deriveJSON lensJSONOptions

deriveLensJSON' :: Char -> Name -> Q [Dec]
deriveLensJSON' sep = deriveJSON (lensJSONOptions' sep)

lensJSONOptions :: Options
lensJSONOptions = lensJSONOptions' '-'

lensJSONOptions' :: Char -> Options
lensJSONOptions' sep =
    defaultOptions
        { fieldLabelModifier = recordToDashedIdentifier sep
        , constructorTagModifier = ctorToDashedIdentifier sep
        }

ctorToDashedIdentifier = camelToDashed

recordToDashedIdentifier sep = camelToDashed sep . stripRecordPrefix

camelToDashed _ ""  = ""
camelToDashed sep (x:y:xs)
    | isLower x && isUpper y = toLower x:sep:camelToDashed sep (y:xs)
    | otherwise = toLower x:camelToDashed sep (y:xs)
camelToDashed sep (x:xs) = toLower x:camelToDashed sep xs

stripRecordPrefix = dropWhile (not . isUpper)
